## AgsFifoout

AgsFifoout — Output to pipe

## Stability Level

Stable, unless otherwise indicated

## Functions

#define | AGS_FIFOOUT_GET_OBJ_MUTEX()
GQuark | ags_fifoout_error_quark ()
gboolean | ags_fifoout_test_flags ()
void | ags_fifoout_set_flags ()
void | ags_fifoout_unset_flags ()
void | ags_fifoout_switch_buffer_flag ()
void | ags_fifoout_adjust_delay_and_attack ()
void | ags_fifoout_realloc_buffer ()
AgsFifoout * | ags_fifoout_new ()

## Properties

gpointer | attack | Read
double | bpm | Read / Write
gpointer | buffer | Read
guint | buffer-size | Read / Write
double | delay-factor | Read / Write
char * | device | Read / Write
guint | dsp-channels | Read / Write
guint | format | Read / Write
guint | pcm-channels | Read / Write
guint | samplerate | Read / Write

## Types and Values

#define | AGS_FIFOOUT_DEFAULT_DEVICE
#define | AGS_FIFOOUT_DEFAULT_APP_BUFFER_SIZE
#define | AGS_FIFOOUT_DEFAULT_RING_BUFFER_SIZE
enum | AgsFifooutFlags
enum | AgsFifooutAppBufferMode
#define | AGS_FIFOOUT_ERROR
enum | AgsFifooutError

## Object Hierarchy

        GFlags
        ╰── AgsFifooutFlags
        GObject
        ╰── AgsFifoout

## Includes

    #include <ags/audio/ags_fifoout.h>

## Description

AgsFifoout represents a pipe and supports output.

## Functions

### AGS_FIFOOUT_GET_OBJ_MUTEX()

    #define AGS_FIFOOUT_GET_OBJ_MUTEX(obj) (&(((AgsFifoout *) obj)->obj_mutex))

### ags_fifoout_error_quark ()

    GQuark
    ags_fifoout_error_quark ();

### ags_fifoout_test_flags ()

    gboolean
    ags_fifoout_test_flags (AgsFifoout *fifoout,
                            AgsFifooutFlags flags);

Test `flags` to be set on `fifoout` .

#### Parameters

fifoout | the AgsFifoout |
flags | the flags |

#### Returns

`TRUE` if flags are set, else `FALSE`

Since: 3.0.0

### ags_fifoout_set_flags ()

    void
    ags_fifoout_set_flags (AgsFifoout *fifoout,
                           AgsFifooutFlags flags);

Enable a feature of `fifoout` .

#### Parameters

fifoout | the AgsFifoout |
flags | see AgsFifooutFlags |

Since: 3.0.0

### ags_fifoout_unset_flags ()

    void
    ags_fifoout_unset_flags (AgsFifoout *fifoout,
                             AgsFifooutFlags flags);

Disable a feature of `fifoout` .

#### Parameters

fifoout | the AgsFifoout |
flags | see AgsFifooutFlags |

Since: 3.0.0

### ags_fifoout_switch_buffer_flag ()

    void
    ags_fifoout_switch_buffer_flag (AgsFifoout *fifoout);

The buffer flag indicates the currently played buffer.

#### Parameters

fifoout | the AgsFifoout |

Since: 3.0.0

### ags_fifoout_adjust_delay_and_attack ()

    void
    ags_fifoout_adjust_delay_and_attack (AgsFifoout *fifoout);

Calculate delay and attack and reset it.

#### Parameters

fifoout | the AgsFifoout |

Since: 3.0.0

### ags_fifoout_realloc_buffer ()

    void
    ags_fifoout_realloc_buffer (AgsFifoout *fifoout);

Reallocate the internal audio buffer.

#### Parameters

fifoout | the AgsFifoout |

Since: 3.0.0

### ags_fifoout_new ()

    AgsFifoout *
    ags_fifoout_new ();

Creates a new instance of AgsFifoout.

#### Returns

the new AgsFifoout

Since: 3.0.0

## Types and Values

### AGS_FIFOOUT_DEFAULT_DEVICE

    #define AGS_FIFOOUT_DEFAULT_DEVICE "/dev/null"

### AGS_FIFOOUT_DEFAULT_APP_BUFFER_SIZE

    #define AGS_FIFOOUT_DEFAULT_APP_BUFFER_SIZE (4)

### AGS_FIFOOUT_DEFAULT_RING_BUFFER_SIZE

    #define AGS_FIFOOUT_DEFAULT_RING_BUFFER_SIZE (8)

### enum AgsFifooutFlags

Enum values to control the behavior or indicate internal state of AgsFifoout by enable/disable as flags.

#### Members

AGS_FIFOOUT_INITIALIZED | the soundcard was initialized |
AGS_FIFOOUT_START_PLAY | playback starting |
AGS_FIFOOUT_PLAY | use first attack, instead of second one |
AGS_FIFOOUT_SHUTDOWN | stop playback |
AGS_FIFOOUT_NONBLOCKING | do non-blocking calls |
AGS_FIFOOUT_ATTACK_FIRST | use first attack, instead of second one |

### enum AgsFifooutAppBufferMode

Enum values to indicate internal state of AgsFifoout application buffer by setting mode.

#### Members

AGS_FIFOOUT_APP_BUFFER_0 | ring-buffer 0 |
AGS_FIFOOUT_APP_BUFFER_1 | ring-buffer 1 |
AGS_FIFOOUT_APP_BUFFER_2 | ring-buffer 2 |
AGS_FIFOOUT_APP_BUFFER_3 | ring-buffer 3 |

### AGS_FIFOOUT_ERROR

    #define AGS_FIFOOUT_ERROR (ags_fifoout_error_quark())

### enum AgsFifooutError

#### Members

AGS_FIFOOUT_ERROR_LOCKED_SOUNDCARD |  |

## Property Details

### The `“attack”` property

      “attack”                   gpointer

Attack of the buffer

Owner: AgsFifoout

Flags: Read

Since: 3.0.0

### The `“bpm”` property

      “bpm”                      double

Beats per minute

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [1,240]

Default value: 120

Since: 3.0.0

### The `“buffer”` property

      “buffer”                   gpointer

The buffer

Owner: AgsFifoout

Flags: Read

Since: 3.0.0

### The `“buffer-size”` property

      “buffer-size”              guint

The buffer size

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [16,16384]

Default value: 2048

Since: 3.0.0

### The `“delay-factor”` property

      “delay-factor”             double

tact

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [0,16]

Default value: 1

Since: 3.0.0

### The `“device”` property

      “device”                   char *

The fifo soundcard indentifier

Owner: AgsFifoout

Flags: Read / Write

Default value: "/dev/null"

Since: 3.0.0

### The `“dsp-channels”` property

      “dsp-channels”             guint

The dsp channel count

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [1,64]

Default value: 2

Since: 3.0.0

### The `“format”` property

      “format”                   guint

The precision of the buffer

Owner: AgsFifoout

Flags: Read / Write

Default value: 16

Since: 3.0.0

### The `“pcm-channels”` property

      “pcm-channels”             guint

The pcm channel count

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [1,64]

Default value: 2

Since: 3.0.0

### The `“samplerate”` property

      “samplerate”               guint

The samplerate

Owner: AgsFifoout

Flags: Read / Write

Allowed values: [8000,5644800]

Default value: 44100

Since: 3.0.0